/* AP 27-sep-12 minprintf.c			*/
/*		vararg-Beispiel	nach K&R	*/

# include <stdarg.h>

int printf(char *, ...);

void minprintf( char * fmt, ... ) {
	va_list ap;
	char *p;
	char *sval;
	int ival;
	double dval;


	va_start( ap, fmt );	
	/* ap zeigt auf erstes unbenanntes Argument */
	for (p = fmt; *p; p++) {
		if (*p != '%') {
			putchar(*p);
			continue;
		}
		switch (*++p) {
		case 'd':
			ival = va_arg( ap, int );
			printf("%d", ival );
			break;
		case 'f':
			dval = va_arg( ap, double );
			printf("%f", dval );
			break;
		case 's':
			for ( sval = va_arg( ap, char *); *sval; sval++ )
				putchar( *sval );
			break;
		default:
			putchar( *p );
			break;
		}
	}
	va_end( ap );
}
