/* AP 08-oct-12	stringops.c				*/
/*		Beispiele fuer Zeichenkettenoperationen	*/

# include <stdio.h>
# include <string.h>
# include <stdlib.h>

int main( int argc, char * argv[] ) {
	char * prog = argv[0];
	char ** p = argv + 1;
	char * s1, * s2;
	int i;

	if (argc < 2) {
		printf("usage: %s <string>\n", prog );
		return 1;
	}
	for ( ; argc > 1 ; argc--, p++ ) {
		s1 = strdup( *p );
		for ( i = 0; i < strlen( s1 ); i++ )
			s1[i] = toupper(s1[i]);	

		s2 = malloc( strlen( *p ) + 1 );
		strcpy( s2, *p );
		for ( i = 0; i < strlen( s2 ); i++ )
			s2[i] = tolower(s2[i]);	

		printf("Original:\t %s\n", *p );
		printf("GROSS:   \t %s\n", s1 );
		printf("klein:	 \t %s\n", s2 );

		free( s1 );
		free( s2 );
	}
	return 0;
}
